# `keyfork shard`

<!-- Linked to: keyfork-user-guide/src/bin/keyfork-shard/index.md -->

Utilities to enable M-of-N sharing of data, using Shamir's Secret Sharing,
supporting multiple formats.

## Options

* `--format`: Either `openpgp` or `p256`, provided anywhere after `split`

### Format: OpenPGP

The secret is split and shares are automatically encrypted to provided OpenPGP
certificates. The resulting output is an OpenPGP ASCII armored message
containing several sequential encrypted messages.

When decrypting, for any missing keys that do not meet the threshold, the
command will prompt for a Yubikey to provide smartcard-based decryption of
shares.

### Format: p256

This section is incomplete as the functionality for p256 keys is not yet
implemented.

## `keyfork shard split`

Split a secret into threshold-of-max shares.

### Arguments

`keyfork shard split --threshold=threshold --max=max key_discovery`

* `threshold`: Minimum number of operators present to recover the secret
* `max`: Maximum number of operators, must equal the amount of keys in
  `key_discovery`
* `key_discovery`: Either a file or a directory containing public keys.
  If a file, load all public keys from a file.
  If a directory, for every file in the directory (non-recursively), load
  public keys from the file.

### Input

Hex-encoded secret, ideally up to 2048 characters. For larger secrets, encrypt
beforehand using a symmetric key (AES256, for example), and split the symmetric
key.

### Output

The output of the command is dependent on the format.

## `keyfork shard combine`

Combine `threshold` shares into a secret.

### Arguments

`keyfork shard combine --threshold=threshold [key_discovery]`

* `threshold`: Mini mum number of operators present to recover the secret
* `key_discovery`: Either a file or a directory containing public keys.
  If a file, load all private keys from a file.
  If a directory, for every file in the directory (non-recursively), load
  private keys from the file.
  If the amount of keys found is less than `threshold`, it is up to the format
  to determine how to discover the keys.

### Input

The input of the command is dependent on the format, but should be the exact
same as the output from the `split` command previously used.

### Output

Hex-encoded secret.
